import io.restassured.RestAssured;
import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;
import io.restassured.specification.RequestSpecification;
import org.json.simple.JSONObject;
import org.junit.*;
import org.openqa.selenium.*;
import org.openqa.selenium.interactions.Actions;
import org.openqa.selenium.remote.DesiredCapabilities;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.Select;
import org.openqa.selenium.support.ui.WebDriverWait;

import java.net.URL;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

public class ManuscriptFlow {
    private static WebDriver driver = null;
    private static WebDriverWait wait = null;
    public String URL = Constants.URL;

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() throws Exception {
        //driver = new RemoteWebDriver(new URL("http://localhost:4444/wd/hub"), DesiredCapabilities.firefox());
        driver = new RemoteWebDriver(new URL("http://localhost:4444/wd/hub"), DesiredCapabilities.chrome());
        //driver.manage().timeouts().implicitlyWait(5, TimeUnit.SECONDS);
        wait = new WebDriverWait(driver, 10);
        String window = driver.getWindowHandle();
        ((JavascriptExecutor) driver).executeScript("alert('Test')");
        driver.switchTo().alert().accept();
        driver.switchTo().window(window);
    }

    @After
    public void tearDown() throws Exception {
        //driver.quit();
    }

    @Test
    public void manuscriptFlow() throws Exception {
        /* Add constants.random after testing this function separably */
        Utils.validLogin( driver,  wait,  URL, Constants.email + /*Constants.randomStr*/ "auth1" + "@thinslices.com", Constants.password);

        WebElement validLogin = null;

        try {
            validLogin = wait.until(ExpectedConditions.presenceOfElementLocated(By.cssSelector("button[data-test='new-manuscript']")));
        } catch (NoSuchElementException e) {

        }

        assertNotNull(validLogin);

        driver.findElement(By.cssSelector("button[data-test='new-manuscript']")).click();

        try {
            wait.until(ExpectedConditions.presenceOfElementLocated(By.cssSelector("button[data-test='submission-next']")));
        } catch (NoSuchElementException e) {

        }

        assertNotNull(driver.findElement(By.cssSelector("button[data-test='submission-next']")));

        // First step submission flow
        driver.findElement(By.cssSelector("[data-test-id='agree-checkbox']")).click();
        driver.findElement(By.cssSelector("button[data-test='submission-next']")).click();

        // Second step submission flow
        try {
             wait.until(ExpectedConditions.presenceOfElementLocated(By.cssSelector(".wizard-step >[data-test-id='row']:nth-of-type(2) span")));
        } catch (NoSuchElementException e) {

        }

        assertEquals("Please provide the details of all the authors of this manuscript, in the order that they appear on the manuscript. Your details have been prefilled as the submitting author.",driver.findElement(By.cssSelector(".wizard-step >[data-test-id='row']:nth-of-type(2) span")).getText());
        assertEquals("MANUSCRIPT TITLE\n*", driver.findElement(By.cssSelector("[data-test-id='submission-title']")).getText());

        driver.findElement(By.cssSelector("input[name='metadata.title']")).sendKeys(Constants.manusName);
        driver.findElement(By.cssSelector("[data-test-id='submission-type']")).click();
        try {
            wait.until(ExpectedConditions.presenceOfElementLocated(By.cssSelector("[data-test-id='submission-type'] div[role=\"option\"]")));
        } catch (NoSuchElementException e) {

        }
        driver.findElement(By.cssSelector("[data-test-id='submission-type'] div[role=\"option\"]:nth-child(1)")).click();
        driver.findElement(By.cssSelector("[data-test-id='submission-abstract'] textarea")).sendKeys(Constants.manusAbstract);
        WebElement element = driver.findElement(By.cssSelector("[name='conflicts.hasConflicts'][value='no']"));

        Utils.scrollToElement(driver, element);
        element.click();

        driver.findElement(By.cssSelector("[name='conflicts.hasDataAvailability'][value='yes']")).click();
        WebElement element1 = driver.findElement(By.cssSelector("[name='conflicts.hasFunding'][value='yes']"));

        Utils.scrollToElement(driver, element1);
        element1.click();

        WebElement element2 = driver.findElement(By.cssSelector("button[data-test='submission-next']"));

        Utils.scrollToElement(driver, element2);
        element2.click();

        // Third step submission flow

        try {
            wait.until(ExpectedConditions.visibilityOf(driver.findElement(By.cssSelector(".wizard-step [level='2']"))));
        } catch (NoSuchElementException e) {

        }
        WebElement pageTitle = driver.findElement(By.cssSelector(".wizard-step [level='2']"));
        assertEquals("3. Manuscript Files Upload", pageTitle.getText());

        try {
            wait.until(ExpectedConditions.visibilityOf(pageTitle));
        } catch (NoSuchElementException e) {

        }

        driver.findElement(By.cssSelector(/*"[data-test='upload-manuscripts']*/"input[type=\"file\"]")).sendKeys(Constants.fileManuscript);
//        driver.findElement(By.cssSelector("[data-test='upload-supplementary'] input[type=\"file\"]")).sendKeys(Constants.fileSupplementary);
//        driver.findElement(By.cssSelector("[data-test='upload-coverLetter'] input[type=\"file\"]")).sendKeys(Constants.fileCoverLetter);

        try {
            wait.until(ExpectedConditions.visibilityOfElementLocated(By.cssSelector("button[data-test='submission-next']")));
        } catch (NoSuchElementException e) {

        }

        WebElement element3 = driver.findElement(By.cssSelector("button[data-test='submission-next']"));
        Utils.scrollToElement(driver, element3);
        element3.click();

        driver.findElement(By.xpath("//button[contains(.,'AGREE & SUBMIT')]")).click();

        try {
            wait.until(ExpectedConditions.visibilityOfElementLocated(By.xpath("//button[contains(.,'GO TO DASHBOARD')]")));
        } catch (NoSuchElementException e) {

        }

        driver.findElement(By.xpath("//button[contains(.,'GO TO DASHBOARD')]")).click();

    }
}
